Subject: bug#47677: closed (Re: bug#47677: [PATCH] condition-case success continuation)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 27 Apr 2021 15:32:02 +0000

Your bug report

#47677: [PATCH] condition-case success continuation

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
47677: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=47677
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#47677: [PATCH] condition-case success continuation
From: Mattias Engdegård <[email-masked]>
To: Filipp Gunbin <[email-masked]>
Cc: Lars Ingebrigtsen <[email-masked]>, Stefan Kangas <[email-masked]>, Stefan Monnier <[email-masked]>, [email-masked]
Date: Tue, 27 Apr 2021 17:31:31 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

26 apr. 2021 kl. 17.12 skrev Filipp Gunbin <[email-masked]>:

> Please, let's not add such features to the basic Emacs Lisp constructs.
> It's great to see Emacs Lisp being simple.

I'd like to clear up some misconceptions here. (Filipp, this does not mean that I think that you wrote something stupid -- quite the contrary.) 

First, is Emacs Lisp really simple? Yes and no. It's not easy to tell where its boundaries are, especially since it doesn't have a proper module or namespace system or a well-defined 'core language'. Basic semantics -- control structures, built-in types, primitives and so on -- are not too messy but definitely more than they need to be; Scheme it is not. No wonder given its age; it has held up remarkably well considering, but it would be even more remarkable if modern eyes could not find flaws in it.

Second, is simplicity paramount among concerns? Clearly not: compatibility matters, and so does programming usability. It is also not clear whether a change makes a language more or less simple; adding bignums, for example, probably made the language less complex for the user. Even if (hypothetically) people got by without `unwind-protect` by catching and re-raising errors, few would object to adding that construct as a special form because it made the language less simple.

Of course you were talking about changes that make the language more difficult to use, but my point is that it is far from clear what kind of change actually does that.

Unrelated to your comment: since several people have misunderstood the proposal, I'm closing the bug to avoid conflating issues (I should have listened to Stefan Kangas); a new one can be reopened for the patch at hand when and if I get more free time.

Subject: [PATCH] condition-case success continuation
From: Mattias Engdegård <[email-masked]>
To: [email-masked]
Date: Fri, 9 Apr 2021 22:26:49 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

This patch adds the condition-case handler syntax

  (:success BODY)

for code executed when the protected form terminates without error. BODY is then executed with the variable bound to the result of the protected form, and the result of BODY is then the value of the condition-case form as usual.

This plugs an annoying hole in elisp: there hasn't been any direct access to the success continuation which forced programmers to resort to various hacks such as tagging the returned value and then immediately testing that tag, as in

(let ((input (condition-case _
                 (cons 'ok (read buffer))
               (end-of-file 'eof))))
  (when (consp input)
    (use (cdr input))))

Now we can write

(condition-case result
    (read buffer)
  (end-of-file 'eof)
  (:success (use result)))

which is more concise, elegant and performant.

Like all condition-case handlers (but in contrast to the protected form), the success handler is in the tail position and the limited self-tail-recursion of cl-labels (and named-let) works there as expected.

Details of the syntax can be changed if there is a very good reason for it. Many other languages have more or less independently added equivalent constructs. Common Lisp's `handler-case` has a very similar feature (:no-error).

It would be nice to give `catch` the same treatment. A particularly flexible solution would be to add `catch` handlers to `condition-case`, which would then be able to handle everything. Unless there is a strong reason for doing it right away, it can be seen as a later improvement.